---
title: NaN
slug: Web/JavaScript/Reference/Global_Objects/NaN
tags:
  - JavaScript
  - Property
  - Reference
---
<div>{{jsSidebar("Objects")}}</div>

<p>The global <code><strong>NaN</strong></code> property is a value representing Not-A-Number.</p>

<p>{{js_property_attributes(0,0,0)}}</p>

<div>{{EmbedInteractiveExample("pages/js/globalprops-nan.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Description">Description</h2>

<p><code>NaN</code> is a property of the <em>global object</em>. In other words, it is a variable in global scope.</p>

<p>The initial value of <code>NaN</code> is Not-A-Number — the same as the value of {{jsxref("Number.NaN")}}. In modern browsers, <code>NaN</code> is a non-configurable, non-writable property. Even when this is not the case, avoid overriding it. It is rather rare to use <code>NaN</code> in a program.</p>

<p>There are five different types of operations that return <code>NaN</code>:</p>

<ul>
 <li>Number cannot be parsed (e.g. <code>parseInt("blabla")</code> or <code>Number(undefined)</code>)</li>
 <li>Math operation where the result is not a real number (e.g. <code>Math.sqrt(-1)</code>)</li>
 <li>Operand of an argument is <code>NaN</code> (e.g. <code>7 ** NaN</code>)</li>
 <li>Indeterminate form (e.g. <code>0 * Infinity</code>, or <code>undefined + undefined</code>)</li>
 <li>Any operation that involves a string and is not an addition operation (e.g. <code>"foo" / 3</code>)</li>
</ul>

<h2 id="Examples">Examples</h2>

<h3 id="Testing_against_NaN">Testing against NaN</h3>

<p><code>NaN</code> compares unequal (via <code>==</code>, <code>!=</code>, <code>===</code>, and <code>!==</code>) to any other value -- including to another <code>NaN</code> value. Use {{jsxref("Number.isNaN()")}} or {{jsxref("Global_Objects/isNaN", "isNaN()")}} to most clearly determine whether a value is <code>NaN</code>. Or perform a self-comparison: <code>NaN</code>, and only <code>NaN</code>, will compare unequal to itself.</p>

<pre class="brush: js notranslate">NaN === NaN;        // false
Number.NaN === NaN; // false
isNaN(NaN);         // true
isNaN(Number.NaN);  // true
Number.isNaN(NaN);  // true

function valueIsNaN(v) { return v !== v; }
valueIsNaN(1);          // false
valueIsNaN(NaN);        // true
valueIsNaN(Number.NaN); // true
</pre>

<p>However, do note the difference between <code>isNaN()</code> and <code>Number.isNaN()</code>: the former will return <code>true</code> if the value is currently <code>NaN</code>, or if it is going to be <code>NaN</code> after it is coerced to a number, while the latter will return <code>true</code> only if the value is currently <code>NaN</code>:</p>

<pre class="brush: js notranslate">isNaN('hello world');        // true
Number.isNaN('hello world'); // false
</pre>

<p>Additionally, some array methods cannot find <code>NaN</code>, while others can.</p>

<pre class="brush: js notranslate">let arr = [2, 4, NaN, 12];
arr.indexOf(NaN);                      // -1 (false)
arr.includes(NaN);                     // true
arr.findIndex(n =&gt; Number.isNaN(n));   // 2
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-value-properties-of-the-global-object-nan', 'NaN')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.NaN")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Number.NaN")}}</li>
 <li>{{jsxref("Number.isNaN()")}}</li>
 <li>{{jsxref("isNaN", "isNaN()")}}</li>
</ul>
